Index: /code/branches/network5/src/libraries/network/ClientConnection.cc
===================================================================
--- /code/branches/network5/src/libraries/network/ClientConnection.cc	(revision 7772)
+++ /code/branches/network5/src/libraries/network/ClientConnection.cc	(revision 7773)
@@ -39,5 +39,4 @@
   const unsigned int NETWORK_CLIENT_CONNECTION_TIMEOUT = 3000; //millisecs
   const unsigned int NETWORK_CLIENT_MAX_CONNECTIONS = 1;
-  const unsigned int NETWORK_CLIENT_CHANNELS = 1;
 
 
@@ -71,5 +70,5 @@
     ENetEvent event;
 
-    this->host_ = enet_host_create(NULL, NETWORK_CLIENT_MAX_CONNECTIONS, 0, 0, 0);
+    this->host_ = enet_host_create(NULL, NETWORK_CLIENT_MAX_CONNECTIONS, NETWORK_CHANNEL_COUNT, 0, 0);
     if ( this->host_ == NULL )
     {
@@ -86,5 +85,5 @@
         COUT(3) << "Info: Using IPv4 and IPv6 Sockets." << std::endl;
 
-    this->server_ = enet_host_connect(this->host_, serverAddress_, NETWORK_CLIENT_CHANNELS, 0);
+    this->server_ = enet_host_connect(this->host_, serverAddress_, NETWORK_CHANNEL_COUNT, 0);
     if ( this->server_==NULL )
     {
@@ -155,4 +154,5 @@
     COUT(1) << "Received disconnect Packet from Server!" << endl;
         // server closed the connection
+    this->stopCommunicationThread();
     this->connectionClosed();
   }
Index: /code/branches/network5/src/libraries/network/GamestateManager.cc
===================================================================
--- /code/branches/network5/src/libraries/network/GamestateManager.cc	(revision 7772)
+++ /code/branches/network5/src/libraries/network/GamestateManager.cc	(revision 7773)
@@ -216,6 +216,6 @@
 
 
-    bool b = gs->compressData();
-    assert(b);
+//     bool b = gs->compressData();
+//     assert(b);
       clock.capture();
       COUT(4) << "diff and compress time: " << clock.getDeltaTime() << endl;
Index: /code/branches/network5/src/libraries/network/NetworkPrereqs.h
===================================================================
--- /code/branches/network5/src/libraries/network/NetworkPrereqs.h	(revision 7772)
+++ /code/branches/network5/src/libraries/network/NetworkPrereqs.h	(revision 7773)
@@ -68,8 +68,9 @@
   extern const char* LAN_DISCOVERY_MESSAGE;
   extern const char* LAN_DISCOVERY_ACK;
-  static const unsigned int LAN_DISCOVERY_PORT        = 55557;
-  static const unsigned int NETWORK_PEER_ID_SERVER    = 0;
-  static const unsigned int NETWORK_CHANNEL_DEFAULT   = 0;
-  static const unsigned int NETWORK_CHANNEL_RELIABLE  = 1;
+  static const unsigned int LAN_DISCOVERY_PORT          = 55557;
+  static const unsigned int NETWORK_PEER_ID_SERVER      = 0;
+  static const unsigned int NETWORK_CHANNEL_DEFAULT     = 0;
+  static const unsigned int NETWORK_CHANNEL_UNRELIABLE  = 1;
+  static const unsigned int NETWORK_CHANNEL_COUNT       = 2;
 }
 
Index: /code/branches/network5/src/libraries/network/Server.cc
===================================================================
--- /code/branches/network5/src/libraries/network/Server.cc	(revision 7772)
+++ /code/branches/network5/src/libraries/network/Server.cc	(revision 7773)
@@ -425,6 +425,6 @@
     if(!b)
       return false; //no data for the client
-    b = g->compressData();
-    assert(b);
+//     b = g->compressData();
+//     assert(b);
     b = g->send();
     assert(b);
Index: /code/branches/network5/src/libraries/network/ServerConnection.cc
===================================================================
--- /code/branches/network5/src/libraries/network/ServerConnection.cc	(revision 7772)
+++ /code/branches/network5/src/libraries/network/ServerConnection.cc	(revision 7773)
@@ -68,5 +68,5 @@
   bool ServerConnection::openListener()
   {
-    this->host_ = enet_host_create(this->bindAddress_, NETWORK_MAX_CONNECTIONS, 0, 0, 0);
+    this->host_ = enet_host_create(this->bindAddress_, NETWORK_MAX_CONNECTIONS, NETWORK_CHANNEL_COUNT, 0, 0);
     if ( this->host_ == NULL )
     {
@@ -91,4 +91,5 @@
     this->bListening_=false;
     disconnectClients();
+    Connection::stopCommunicationThread();
     enet_host_destroy(this->host_);
     return true;
Index: /code/branches/network5/src/libraries/network/packet/Packet.cc
===================================================================
--- /code/branches/network5/src/libraries/network/packet/Packet.cc	(revision 7772)
+++ /code/branches/network5/src/libraries/network/packet/Packet.cc	(revision 7773)
@@ -169,7 +169,7 @@
 //  enetPacket_ = 0; // otherwise we have a double free because enet already handles the deallocation of the packet
   if( this->flags_ & PacketFlag::Reliable )
-    Host::addPacket( enetPacket_, clientID_, 0);
+    Host::addPacket( enetPacket_, clientID_, NETWORK_CHANNEL_DEFAULT);
   else
-    Host::addPacket( enetPacket_, clientID_, 0);
+    Host::addPacket( enetPacket_, clientID_, NETWORK_CHANNEL_UNRELIABLE);
   return true;
 }