Index: branches/gui/src/lib/gui/gl_gui/glgui_slider.cc
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_slider.cc	(revision 7941)
+++ branches/gui/src/lib/gui/gl_gui/glgui_slider.cc	(revision 7942)
@@ -25,6 +25,6 @@
 
   /**
-   * standard constructor
-  */
+   * @brief standard constructor
+   */
   GLGuiSlider::GLGuiSlider ()
   {
@@ -35,11 +35,11 @@
 
   /**
-   * standard deconstructor
-  */
+   * @brief standard deconstructor
+   */
   GLGuiSlider::~GLGuiSlider()
   {}
 
   /**
-   * initializes the GUI-element
+   * @brief initializes the GUI-element
    */
   void GLGuiSlider::init()
@@ -62,5 +62,8 @@
   }
 
-
+  /**
+   * @param value the new Value.
+   * @note will automatically be set between max() and min()
+   */
   void GLGuiSlider::setValue(float value)
   {
@@ -74,8 +77,13 @@
   }
 
+  /**
+   * @param minimum the minumum of the range.
+   *
+   * @note will rearange value if necessary and will not be made bigger than max()
+   */
   void GLGuiSlider::setMin(float minimum)
   {
     if (minimum <= max())
-     this->_minValue = minimum;
+      this->_minValue = minimum;
 
     if (this->value() < minimum)
@@ -83,4 +91,10 @@
   }
 
+
+  /**
+   * @param maximum the maximum of the range.
+   *
+   * @note will rearange value if necessary and will not be made smaller than min()
+   */
   void GLGuiSlider::setMax(float maximum)
   {
@@ -92,4 +106,11 @@
   }
 
+  /**
+   * @param minimum the minimum
+   * @param maximum the maximum
+   *
+   * @see setMax
+   * @see setMin
+   */
   void GLGuiSlider::setRange(float minimum, float maximum)
   {
@@ -105,4 +126,7 @@
   }
 
+  /**
+   * @brief sets the stepSize
+   */
   void GLGuiSlider::setStep(float step)
   {
@@ -110,13 +134,34 @@
   }
 
-
+  /**
+   * @brief makes one step into the minus direction
+   */
+  void GLGuiSlider::stepMinus()
+  {
+    this->setValue(value() - step());
+  }
+
+  /**
+   * @brief makes one step into the minus direction
+   */
+  void GLGuiSlider::stepPlus()
+  {
+    this->setValue(value() + step());
+  }
+
+  /**
+   * @brief resizes the Slider, and through this Synchronizes the GUI-size.
+   */
   void GLGuiSlider::resize()
   {
     GLGuiWidget::resize();
-    this->frontRect().setTopLeft(5, this->getSizeY2D()/2.0 - borderSize());
-    this->frontRect().setSize(this->getSizeX2D() - 10.0, borderSize());
-  }
-
-
+    this->frontRect().setTopLeft(5, this->getSizeY2D()/2.0 - 2.0);
+    this->frontRect().setSize(this->getSizeX2D() - 10.0, 4.0);
+  }
+
+  /**
+   * @brief handle the clicked event.
+   * @param pos the position the Click occured (from the topleft corner out)
+   */
   void GLGuiSlider::clicked(const Vector2D& pos)
   {
@@ -131,8 +176,4 @@
     else
       this->grabbed = true;
-
-
-
-    printf("clicked at position: "), pos.debug();
   }
 
@@ -149,32 +190,27 @@
   }
 
+  /**
+   * @returns the current SliderPosition calculated from the current value and the Silders' size.
+   */
   float GLGuiSlider::sliderPosition() const
   {
     return (this->_value - this->_minValue)/( this->_maxValue - this->_minValue) *
-        (this->getSizeX2D() - 2.0*(borderSize() + _sliderWidth)) +
-        (borderSize() +_sliderWidth);
-  }
-
+           (this->getSizeX2D() - 2.0*(borderSize() + _sliderWidth)) +
+           (borderSize() +_sliderWidth);
+  }
+
+  /**
+   * @param position the position relative from the left border.
+   * @returns the Value at the given position.
+   */
   float GLGuiSlider::sliderValue(float position) const
   {
     return (position - (borderSize()+_sliderWidth)) / (this->getSizeX2D() - 2.0*(borderSize() + _sliderWidth))
-        *( this->_maxValue - this->_minValue) +
-        this->_minValue ;
-  }
-
-  /*  virtual void GLGuiSlider::tick(float dt)
-    {
-      if (this->grabbed)
-      {
-        this->setValue( 1);
-      }
-    }*/
+           *( this->_maxValue - this->_minValue) +
+           this->_minValue ;
+  }
 
   void GLGuiSlider::tick(float dt)
   {
-/*    this->setValue(this->value() + dt);
-    if (this->value() >= this->max())
-    this->setValue(this->min());
-*/
   }
 
@@ -203,4 +239,17 @@
       return true;
     }
+    else if (event.bPressed)
+    {
+      if (event.type == SDLK_LEFT)
+      {
+        this->stepMinus();
+        return true;
+      }
+      else if (event.type == SDLK_RIGHT)
+      {
+        this->stepPlus();
+        return true;
+      }
+    }
     return false;
   }
Index: branches/gui/src/lib/gui/gl_gui/glgui_slider.h
===================================================================
--- branches/gui/src/lib/gui/gl_gui/glgui_slider.h	(revision 7941)
+++ branches/gui/src/lib/gui/gl_gui/glgui_slider.h	(revision 7942)
@@ -43,4 +43,6 @@
     void setStep(float step);
 
+    void stepPlus();
+    void stepMinus();
 
     virtual void tick(float dt);
@@ -59,6 +61,6 @@
     float sliderPosition() const;
     float sliderValue(float position) const;
+
   private:
-
     Orientation      orientation;
 