Index: /code/branches/kicklib/data/gui/scripts/GUITools.lua
===================================================================
--- /code/branches/kicklib/data/gui/scripts/GUITools.lua	(revision 7960)
+++ /code/branches/kicklib/data/gui/scripts/GUITools.lua	(revision 7961)
@@ -31,6 +31,6 @@
 
     local lookAndFeel = CEGUI.WidgetLookManager:getSingleton():getWidgetLook(window:getLookNFeel())
-    local height = window:getFont():getLineSpacing() + window:getUnclippedPixelRect():getHeight() - lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window):getHeight()
-    local width =  window:getFont():getTextExtent(window:getText()) + window:getUnclippedPixelRect():getWidth() - lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window):getWidth()
+    local height = window:getFont():getLineSpacing() + window:getUnclippedOuterRect():getHeight() - lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window):getHeight()
+    local width =  window:getFont():getTextExtent(window:getText()) + window:getUnclippedOuterRect():getWidth() - lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window):getWidth()
 
     table.insert(size, height)
@@ -40,6 +40,6 @@
 
 function getScrollingStepSize(window)
-    local height = window:getUnclippedPixelRect():getHeight()
-    local maxHeight = CEGUI.System:getSingleton():getGUISheet():getUnclippedPixelRect():getHeight()
+    local height = window:getUnclippedOuterRect():getHeight()
+    local maxHeight = CEGUI.System:getSingleton():getGUISheet():getUnclippedOuterRect():getHeight()
     local ratio = height/maxHeight
     return 0.008*ratio/0.3204
@@ -49,5 +49,5 @@
     local lookAndFeel = CEGUI.WidgetLookManager:getSingleton():getWidgetLook(window:getLookNFeel())
     local formattedArea = lookAndFeel:getNamedArea("WithFrameTextRenderArea"):getArea():getPixelRect(window)
-    local frameHeight = window:getUnclippedPixelRect():getHeight() - formattedArea:getHeight()
+    local frameHeight = window:getUnclippedOuterRect():getHeight() - formattedArea:getHeight()
     local lines = window:getFont():getFormattedLineCount(window:getText(), formattedArea, CEGUI.WordWrapLeftAligned)
     local height = lines * window:getFont():getLineSpacing() + frameHeight
Index: /code/branches/kicklib/data/gui/scripts/InitialiseGUI.lua
===================================================================
--- /code/branches/kicklib/data/gui/scripts/InitialiseGUI.lua	(revision 7960)
+++ /code/branches/kicklib/data/gui/scripts/InitialiseGUI.lua	(revision 7961)
@@ -7,25 +7,25 @@
 local scheme = orxonox.CommandExecutor:query("getConfig GUIManager guiScheme_")
 -- Load all required skins
---schemeMgr:loadScheme("TaharezGreenLook.scheme")
-schemeMgr:loadScheme(scheme .. "Look.scheme")
---schemeMgr:loadScheme("TaharezLook.scheme")
---schemeMgr:loadScheme("WindowsLook.scheme")
---schemeMgr:loadScheme("VanillaLook.scheme")
---schemeMgr:loadScheme("SleekSpaceLook.scheme")
+--schemeMgr:create("TaharezGreenLook.scheme")
+schemeMgr:create(scheme .. "Look.scheme")
+--schemeMgr:create("TaharezLook.scheme")
+--schemeMgr:create("WindowsLook.scheme")
+--schemeMgr:create("VanillaLook.scheme")
+--schemeMgr:create("SleekSpaceLook.scheme")
 
 -- Connect skin specific window types with our own window types
 -- By loading a different file (if there is) you can change the skin
 -- of the menus or the HUD independently
---schemeMgr:loadScheme("TaharezGreenMenuWidgets.scheme")
+--schemeMgr:create("TaharezGreenMenuWidgets.scheme")
 --menuImageSet = "TaharezGreenLook"
---schemeMgr:loadScheme("TaharezGreenHUDWidgets.scheme")
+--schemeMgr:create("TaharezGreenHUDWidgets.scheme")
 --hudImageSet = "TaharezGreenLook"
-schemeMgr:loadScheme(scheme .. "MenuWidgets.scheme")
+schemeMgr:create(scheme .. "MenuWidgets.scheme")
 menuImageSet = scheme .. "Look"
-schemeMgr:loadScheme(scheme .. "HUDWidgets.scheme")
+schemeMgr:create(scheme .. "HUDWidgets.scheme")
 hudImageSet = scheme .. "Look"
 
 -- Just a remaining test hack
-schemeMgr:loadScheme("OrxonoxGUIScheme.scheme")
+schemeMgr:create("OrxonoxGUIScheme.scheme")
 
 local system = CEGUI.System:getSingleton()
Index: /code/branches/kicklib/data/gui/scripts/NotificationLayer.lua
===================================================================
--- /code/branches/kicklib/data/gui/scripts/NotificationLayer.lua	(revision 7960)
+++ /code/branches/kicklib/data/gui/scripts/NotificationLayer.lua	(revision 7961)
@@ -484,5 +484,5 @@
     local lookAndFeel = CEGUI.WidgetLookManager:getSingleton():getWidgetLook(queue:getLookNFeel())
     local formattedArea = lookAndFeel:getNamedArea("ItemRenderingArea"):getArea():getPixelRect(queue)
-    local frameHeight = queue:getUnclippedPixelRect():getHeight() - formattedArea:getHeight()
+    local frameHeight = queue:getUnclippedOuterRect():getHeight() - formattedArea:getHeight()
     listbox:removeItem(item)
     return frameHeight + singleItemHeight*size
Index: /code/branches/kicklib/src/libraries/core/GUIManager.cc
===================================================================
--- /code/branches/kicklib/src/libraries/core/GUIManager.cc	(revision 7960)
+++ /code/branches/kicklib/src/libraries/core/GUIManager.cc	(revision 7961)
@@ -173,4 +173,7 @@
 #if CEGUI_VERSION_MAJOR < 1 && CEGUI_VERSION_MINOR < 7
         guiSystem_ = new System(guiRenderer_, resourceProvider_, 0, scriptModule_);
+        // Add functions that have been renamed in newer versions
+        luaState_->doString("CEGUI.SchemeManager.create = CEGUI.SchemeManager.loadScheme");
+        luaState_->doString("CEGUI.Window.getUnclippedOuterRect = CEGUI.Window.getUnclippedPixelRect");
 #else
         guiSystem_ = &System::create(*guiRenderer_, resourceProvider_, 0, imageCodec_, scriptModule_);